'article_html.layoutgram'.
'article.gram'.
article.
text.
article(article) --> !.
dateoptional('[date]') --> !.
dateoptional(A) --> date(A).
date('[date]'(A)) --> date(date(A)).
article(article(A,B,C,D)) --> {write('<HEAD><TITLE>Document</TITLE></HEAD>')},{nl},{write('<BODY>')},{nl},authors(A),{nl},{nl},dateoptional(B),{nl},{nl},title(C),{nl},{nl},content(D),{nl},{write('</BODY>')}.
authors(authors) --> !.
authorlist([A,'author+']) --> author(A),!.
authorlist([A,B,'author+']) --> author(A),{nl},author(B).
authorlist([A|B]) --> author(A),{nl},authorlist(B).
authors(authors(A)) --> authorlist(A).
author(author) --> !.
author(author(A)) --> {write('<P>')},text(A).
date(date) --> !.
date(date(A)) --> {write('<P>')},text(A).
title(title) --> !.
title(title(A)) --> {write('<H1>')},text(A),{write('</H1>')}.
content(content) --> !.
sectionlist([A,'section+']) --> section(A),!.
sectionlist([A,B,'section+']) --> section(A),{nl, nl},section(B).
sectionlist([A|B]) --> section(A),{nl, nl},sectionlist(B).
content(content(A,B)) --> abstract(A),{nl},{nl},sectionlist(B).
abstract(abstract) --> !.
abstract(abstract(A)) --> {write('<P>')},text(A).
section(section) --> !.
paragraphlist([A,'paragraph+']) --> paragraph(A),!.
paragraphlist([A,B,'paragraph+']) --> paragraph(A),{nl},paragraph(B).
paragraphlist([A|B]) --> paragraph(A),{nl},paragraphlist(B).
section(section(A,B)) --> {write('<H2>')},heading(A),{write('</H2>')},paragraphlist(B).
heading(heading) --> !.
heading(heading(A)) --> text(A).
paragraph(paragraph) --> !.
paragraph(paragraph(A)) --> textpara(A).
paragraph(paragraph) --> !.
paragraph(paragraph(A)) --> {write('<UL>')},itemizelist(A),{write('</UL>')}.
itemizelist(itemizelist) --> !.
itemizelist([A,'itemize+']) --> itemize(A),!.
itemizelist([A,B,'itemize+']) --> itemize(A),{nl},itemize(B).
itemizelist([A|B]) --> itemize(A),{nl},itemizelist(B).
itemizelist(itemizelist(A)) --> itemizelist(A).
textpara(textpara) --> !.
textpara(textpara(A)) --> {write('<P>')},text(A).
itemize(itemize) --> !.
itemize(itemize(A)) --> {write('<LI>')},text(A).
text(text(A)) --> {write(A)}.
